.model  tiny

        include astr.inc

.data
ioMPU           word    331h

.code
        .startup
        mov     ah, 0FFh
        call    MPU_writeCommand
        mov     ah, 0FFh
        call    MPU_writeCommand
        .if     carry?
          mov   ah, 9
          astr  <mov dx, offset>,<"no MPU-401 found at all$">
          int   21h
          mov   ax, 4C01h
          int   21h
        .endif
        mov     ah, 0ACh
        call    MPU_writeCommand
        .if     carry?
cantGet:
          mov   ah, 9
          astr  <mov dx, offset>,<"could not get MPU version in NORMAL mode$">
          int   21h
          mov   ax, 4C01h
          int   21h
        .endif
        call    MPU_readByte
        jc      cantGet

        mov     ah, 03Fh
        call    MPU_writeCommand
        .if     carry?
          mov   ah, 9
          astr  <mov dx, offset>,<"could not enter UART mode$">
          int   21h
          mov   ax, 4C01h
          int   21h
        .endif

        mov     ah, 0ACh
        call    MPU_writeCommand
        .if     carry?
          mov   ah, 9
          astr  <mov dx, offset>,<"Correct! A real MPU-401 does not acknowledge version in UART mode.$">
          int   21h
        .else
          mov   ah, 9
          astr  <mov dx, offset>,<"Wrong! A real MPU-401 does not return version in UART mode.$">
          int   21h
          mov   ax, 4C01h
          int   21h
        .endif
        mov     ah, 0FFh
        call    MPU_writeCommand
        mov     ax, 4C00h
        int     21h

MPU_writeCommand        proc
        cli
        xor     cx, cx
        mov     dx, [ioMPU]
@@:     in      al, dx
        test    al, 40h
        jz      @f
        loop    @b
        stc
        sti
        ret
@@:     mov     al, ah
        out     dx, al
        xor     cx, cx
@@:     in      al, dx
        test    al, 80h
        jz      @f
        loop    @b
        stc
        sti
        ret
@@:     dec     dx
        in      al, dx
        clc
        sti
        ret
MPU_writeCommand        endp

MPU_readByte            proc
        cli
        xor     cx, cx
        mov     dx, [ioMPU]
@@:     in      al, dx
        test    al, 80h
        jz      @f
        loop    @b
        stc
        sti
        ret
@@:
        dec     dx
        in      al, dx
        clc
        sti
        ret
MPU_readByte            endp
        end
